######################################
# Emulation Logger Compilation flags #
######################################

#
# Emulation Module logging compilation options and
# Emulation Module logging levels
#
# If the global emulation flag is disabled no logs will be showed
# regardless of the per module definitions.
# If you want per module definitions, enable the global
# IWL_EMULATION_LOG_ENABLED flag and enable/disable the per module log.
#

# Enable Emulation Logs
#EXTRA_CFLAGS            += -DIWL_EMULATION_LOG_ENABLED

# Global Emulation
EXTRA_CFLAGS 		+= -D__IWL_EMULATION_LOG_ENABLED__
EXTRA_CFLAGS 		+= -D__EMULATION_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS 		+= -D__EMULATION_LOG_LEVEL_TRACE__="KERN_DEBUG"

# IDI
EXTRA_CFLAGS 		+= -D__IWL_IDI_LOG_ENABLED__
EXTRA_CFLAGS 		+= -D__IDI_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS 		+= -D__IDI_LOG_LEVEL_TRACE__="KERN_DEBUG"

# IDI RX
EXTRA_CFLAGS 		+= -D__IWL_IDI_RX_LOG_ENABLED__
EXTRA_CFLAGS 		+= -D__IDI_RX_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS 		+= -D__IDI_RX_LOG_LEVEL_TRACE__="KERN_DEBUG"

# IDI TX
EXTRA_CFLAGS 		+= -D__IWL_IDI_TX_LOG_ENABLED__
EXTRA_CFLAGS 		+= -D__IDI_TX_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS 		+= -D__IDI_TX_LOG_LEVEL_TRACE__="KERN_DEBUG"

# LLS
EXTRA_CFLAGS           += -D__IWL_LLS_LOG_ENABLED__
EXTRA_CFLAGS           += -D__LLS_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS           += -D__LLS_LOG_LEVEL_TRACE__="KERN_DEBUG"

# SFDB
EXTRA_CFLAGS           += -D__IWL_SFDB_LOG_ENABLED__
EXTRA_CFLAGS           += -D__SFDB_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS           += -D__SFDB_LOG_LEVEL_TRACE__="KERN_DEBUG"

# AMFH
EXTRA_CFLAGS 		+= -D__IWL_AMFH_LOG_ENABLED__
EXTRA_CFLAGS 		+= -D__AMFH_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS 		+= -D__AMFH_LOG_LEVEL_TRACE__="KERN_DEBUG"

# INTA
EXTRA_CFLAGS 		+= -D__IWL_INTA_LOG_ENABLED__
EXTRA_CFLAGS 		+= -D__INTA_LOG_LEVEL_DEBUG__="KERN_INFO"
EXTRA_CFLAGS 		+= -D__INTA_LOG_LEVEL_TRACE__="KERN_DEBUG"
